<?php

namespace Drupal\salesforce_mfw\Routing;

use Drupal\Core\Routing\RouteSubscriberBase;
use Drupal\Core\Routing\RoutingEvents;
use Symfony\Component\Routing\RouteCollection;

/**
 * Adds additional requirements for salesforce block routes.
 */
class RouteSubscriber extends RouteSubscriberBase {

  /**
   * The routes to provide additional access checks to.
   */
  protected const ROUTES = [
    'entity.block.delete_form' => 'delete',
    'entity.block.edit_form' => 'edit',
    'entity.block.enable' => 'enable',
    'entity.block.disable' => 'disable',
    'block.admin_add' => 'create',
  ];

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    foreach (static::ROUTES as $route_name => $operation) {
      if ($route = $collection->get($route_name)) {
        $route->setRequirement('_salesforce_mfw_access', $operation);
      }
    }
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents(): array {
    $events[RoutingEvents::ALTER] = ['onAlterRoutes', -100];
    return $events;
  }

}
